// ***************************************
// Best practice library v0.1.1 (07/09/07)
// ***************************************

// Author: Jonathan Abbott

// Designed to provide a consistent Gadget look whilst complying with
// Windows Vista User Experience Guidlines for the Sidebar

// URL: http://msdn2.microsoft.com/en-us/library/aa974179.aspx


function _BPimage(str, absolute) {
	if (absolute)
		return System.Gadget.path + "/bestPractice/images/" + str + ".png";
	else
		return "bestPractice/images/" + str + ".png";
}


// BP_Loading: Display a blank background with a loading percentage info indicator
// Usage:
//		BP_Loading() / BP_Loading(0)	- Show a waiting animation instead of a percentage
//		BP_Loading(<percentage>)		- Show a progress bar at X percent
//		BP_Loading(100)					- Cleanup, removing the elements from the page

var BP_loading_showing = false;
var BP_loading_percentage = 0;
var BP_loading_animation = false;
var BP_loading_animation_index = 0;

function BP_Loading(iPercentage, sInfo) {
try{
	if (sInfo == null) sInfo = "Loading...";

	// initialise if this is the first call
	if (BP_loading_showing == false) {
		// set the Gadget size and background image
		document.body.style.width = 130;
		document.body.style.height = 67;
		System.Gadget.background = _BPimage("loadingbackground");

		// create the centered div to hold the info
		var tmp = document.createElement("<div id='div_BP_loadingBody' style='position:absolute; top:50%; left:50%;'></div>");
		document.body.appendChild(tmp);

		var tmp = document.createElement("<div id='div_BP_loadingInfo' style='position:relative; top:-50%; left:-50%;'></div>");
		div_BP_loadingBody.appendChild(tmp);

		tmp = document.createElement("<div id='div_BP_loadingContent' style='position:relative; text-align:center; color:white; font-size:12px; font-family:Segoe UI;'></div>");
		div_BP_loadingInfo.appendChild(tmp);

		// create the info icon
		tmp = document.createElement("<img id='img_BP_Wait' src='" + _BPimage((iPercentage ? "infoicon_info" : "infoicon_wait00")) + "' style='position:relative; margin:0 4px -4px 0;' />");
		div_BP_loadingContent.appendChild(tmp);

		// create the info icon
		tmp = document.createElement("<div id='div_BP_loadingInfoText' style='display:inline;'></div>");
		div_BP_loadingContent.appendChild(tmp);

		// if we're not showing a percentage, use an animated wait icon
		if (!iPercentage)
			BP_loading_animation = window.setInterval(BP_Wait_Animation, 50);

		div_BP_loadingInfoText.innerText = sInfo;

		// create the progress bar
		if (iPercentage) {
			tmp = document.createElement("<div id='div_BP_progress' style='display:inline; text-align:center;'>");
			div_BP_loadingContent.appendChild(tmp);
	
			tmp = document.createElement("<div id='div_BP_percentage' style='position:relative; top:4px; width:102px; height:8px; overflow:hidden; text-align:left;'>");
			div_BP_progress.appendChild(tmp);
	
			tmp = document.createElement("<img src='" + _BPimage("ProgressBackgroundLeft") + "' style='position:absolute; top:0px; left:0px; height:100%' />");
			div_BP_percentage.appendChild(tmp);
			tmp = document.createElement("<img src='" + _BPimage("ProgressBackgroundMiddle") + "' style='position:absolute; top:0px; left:2px; background-color:white; width:98px; height:100%;' />");
			div_BP_percentage.appendChild(tmp);
			tmp = document.createElement("<img src='" + _BPimage("ProgressBackgroundRight") + "' style='position:absolute; top:0px; left:100px; height:100%' />");
			div_BP_percentage.appendChild(tmp);
	
			tmp = document.createElement("<div id='div_BP_percentage_body' style='position:absolute; top:1px; left:1px; width:100px; height:6px; overflow:hidden;'>");
			div_BP_percentage.appendChild(tmp);
	
			BP_loading_percentage = parseInt(iPercentage);
			tmp = document.createElement("<img id='img_BP_percentage' src='" + _BPimage("ProgressPercentage") + "' style='width:" + BP_loading_percentage + "%; height:100%;' />");
			div_BP_percentage_body.appendChild(tmp);
		}

		BP_loading_showing = true;
		return;
	} else if (iPercentage >= 100) {
		BP_loading_showing = false;

		// clear the animation timer if it's running
		try{
			if (BP_loading_animation) window.clearTimeout(BP_loading_animation);
		} catch(err) {}

		// remove the elements
		var tmp = div_BP_loadingBody.cloneNode(false); // no child nodes;
		div_BP_loadingBody.parentNode.replaceChild(tmp, div_BP_loadingBody);

		return;
	} else if (iPercentage != null) {
		BP_loading_percentage = parseInt(iPercentage);
		img_BP_percentage.style.width = BP_loading_percentage + "%";
		div_BP_loadingInfoText.innerText = sInfo;
	}
} catch(err) {_BPerror("BP_Loading", err)}
}


function _BPerror(str, err) {
	System.Debug.outputString(str + ": " + err.name + " - " + err.message);
}


function BP_Wait_Animation() {
try{
	BP_loading_animation_index = (BP_loading_animation_index + 1) % 18;

	img_BP_Wait.src = _BPimage("infoicon_wait" + BP_loading_animation_index);
} catch(err) {_BPerror("BP_Wait_Animation", err)}
}